var x = 10;


// objet singleton
var p1 = {
  nom:"buffa",
  prenom:"michel",
  getNomComplet: function() {
    return this.prenom + " " + this.nom;
  }
};

// Une pseudo classe: une fonction constructeur
// par convention : commence par une majuscule
function Personne(n, p) {
  this.nom = n;
  this.prenom = p;
  
  this.getNomComplet = function() {
    return this.prenom + " " + this.nom;
  }; 
}
  
p2 = new Personne("Travolta", "John");
p3 = new Personne("Cage", "Nicolas");


function Jeu() {
	var monstre = {
		x:10,
		y:10
	}

	function initGame() {
		// charger les images, créer les
		// ennemis etc...
		console.log("initGame");
	}

	var startGame = function() {
		// ici on démarre l'animation
		// graphique
		console.log("startGame");
	}
	function stopGame() {
		// ici on démarre l'animation
		// graphique
		console.log("stopGame");
	}

	function boucleAnimation() {
		// ici on efface, on dessine, on
		// deplace, etc..
	}

	function detecteCollision() {
		console.log("collision");
	}

	// on expose juste ce qu'il faut
	return {
		start: startGame,
		stop: stopGame
	}
}

// Les tableaux

var tab = [];

tab.push(new Personne("Buffa", "Michel"));
tab.push(new Personne("Alami", "karim"));

//tab[1] = 2;
//tab.push(new Jeu());

// iteration méthode 1
for(var i = 0; i < tab.length; i++) {
	console.log(tab[i].getNomComplet());
}

// iterateur methode 2
tab.forEach(function(elem, index) {
	console.log("Element " + index + 
		" val = " + elem.getNomComplet());
})

// subtilité : tableau et objets presque pareils
tab.leonardo = "di caprio";

// iterer sur les propriétés d'un objet
for(var p in p3) {
	console.log("p = " + p);
}












